## com.lowagie.text.pdf.codec.postscript
Class PAPencil

    java.lang.Object
      com.lowagie.text.pdf.codec.postscript.PAPencil

    public class PAPencil

extends java.lang.Object

Nested Class Summary
`protected static class` `PAPencil.State`

Field Summary
`protected java.util.HashMap` `fonts` The font hashtable with postscript names as keys
`java.awt.Graphics2D` `graphics` The current graphics device
`protected java.util.Stack` `gStack` The stack of graphic states.
`protected java.awt.Dimension` `size` The canvas size.
`protected PAPencil.State` `state` The current graphics state.

Constructor Summary
`PAPencil(java.awt.Component component)`
`PAPencil(java.awt.Graphics graphics, java.awt.Dimension size)`

Method Summary
`void` `arc(double cx, double cy, double r, double ang1, double ang2)`
`void` `arcn(double cx, double cy, double r, double ang1, double ang2)`
`void` `charpath(java.lang.String aString, boolean adjustForStroking)`
`void` `clip()`
`void` `clippath()`
`void` `closepath()`
`void` `curveto(double x1, double y1, double x2, double y2, double x3, double y3)`
`void` `eofill()`
`void` `erasepage()`
`void` `fill()`
`java.awt.Font` `findFont(java.lang.String fontname)`
`void` `grestore()`
`void` `grestoreall()`
`void` `gsave()`
`void` `initgraphics()`
`void` `lineto(double x, double y)`
`void` `lineto(java.awt.geom.Point2D p)`
`void` `moveto(double x, double y)`
`void` `moveto(java.awt.geom.Point2D p)`
`void` `newpath()`
`void` `rcurveto(double dx1, double dy1, double dx2, double dy2, double dx3, double dy3)`
`void` `rectfill(double x, double y, double width, double height)`
`void` `rectfill(java.awt.geom.Rectangle2D rect)`
`void` `rectpath(double x, double y, double width, double height)`
`void` `rectstroke(double x, double y, double width, double height)`
`void` `rectstroke(java.awt.geom.Rectangle2D rect)`
`void` `rlineto(double dx, double dy)`
`void` `rmoveto(double dx, double dy)`
`void` `show(java.lang.String string)`
`void` `showpage()`
`void` `stroke()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### size

    protected java.awt.Dimension size

  The canvas size.

### state

    protected PAPencil.State state

  The current graphics state.

### gStack

    protected java.util.Stack gStack

  The stack of graphic states.

### fonts

    protected java.util.HashMap fonts

  The font hashtable with postscript names as keys

### graphics

    public java.awt.Graphics2D graphics

  The current graphics device

Constructor Detail

### PAPencil

    public PAPencil(java.awt.Component component)

### PAPencil

    public PAPencil(java.awt.Graphics graphics,
                    java.awt.Dimension size)

Method Detail

### gsave

    public void gsave()

### grestore

    public void grestore()

### grestoreall

    public void grestoreall()

### initgraphics

    public void initgraphics()

### newpath

    public void newpath()

### moveto

    public void moveto(double x,
                       double y)

### moveto

    public void moveto(java.awt.geom.Point2D p)

### rmoveto

    public void rmoveto(double dx,
                        double dy)
                 throws PainterException

  Throws:
    `PainterException`

### lineto

    public void lineto(double x,
                       double y)
                throws PainterException

  Throws:
    `PainterException`

### lineto

    public void lineto(java.awt.geom.Point2D p)
                throws PainterException

  Throws:
    `PainterException`

### rlineto

    public void rlineto(double dx,
                        double dy)
                 throws PainterException

  Throws:
    `PainterException`

### arc

    public void arc(double cx,
                    double cy,
                    double r,
                    double ang1,
                    double ang2)

  Parameters:
    `cx` - double Centerpoint x
    `cy` - double Centerpoint y
    `r` - double Radius r
    `ang1` - double first angle
    `ang2` - double second angle

### arcn

    public void arcn(double cx,
                     double cy,
                     double r,
                     double ang1,
                     double ang2)

### curveto

    public void curveto(double x1,
                        double y1,
                        double x2,
                        double y2,
                        double x3,
                        double y3)
                 throws PainterException

  Throws:
    `PainterException`

### rcurveto

    public void rcurveto(double dx1,
                         double dy1,
                         double dx2,
                         double dy2,
                         double dx3,
                         double dy3)
                  throws PainterException

  Throws:
    `PainterException`

### closepath

    public void closepath()

### clippath

    public void clippath()

### clip

    public void clip()

### erasepage

    public void erasepage()

### charpath

    public void charpath(java.lang.String aString,
                         boolean adjustForStroking)
                  throws PainterException

  Throws:
    `PainterException`

### showpage

    public void showpage()

### show

    public void show(java.lang.String string)
              throws PainterException

  Throws:
    `PainterException`

### fill

    public void fill()

### eofill

    public void eofill()

### stroke

    public void stroke()
                throws PainterException

  Throws:
    `PainterException`

### rectfill

    public void rectfill(double x,
                         double y,
                         double width,
                         double height)

### rectfill

    public void rectfill(java.awt.geom.Rectangle2D rect)

### rectstroke

    public void rectstroke(double x,
                           double y,
                           double width,
                           double height)
                    throws PainterException

  Throws:
    `PainterException`

### rectstroke

    public void rectstroke(java.awt.geom.Rectangle2D rect)
                    throws PainterException

  Throws:
    `PainterException`

### rectpath

    public void rectpath(double x,
                         double y,
                         double width,
                         double height)

### findFont

    public java.awt.Font findFont(java.lang.String fontname)